# coding: utf-8

"""
    EHESO API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr
from eheso_api_client.models.field_info_basic_response_info import FieldInfoBasicResponseInfo

class FieldInfoBasicResponse(BaseModel):
    """
    FieldInfoBasicResponse
    """
    unique_id: Optional[StrictStr] = Field(default=None, alias="uniqueId", description="The unique identifier for the field.")
    field_id: Optional[StrictStr] = Field(default=None, alias="fieldId", description="The identifier for the field.")
    field_name: Optional[StrictStr] = Field(default=None, alias="fieldName", description="The name of the field.")
    field_type: Optional[StrictStr] = Field(default=None, alias="fieldType", description="The data type of the field.")
    field_sub_type: Optional[StrictStr] = Field(default=None, alias="fieldSubType", description="Some fields have a sub-type. E.g. year is a subtype of number")
    is_calculated: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="isCalculated", description="Indicates if the field is calculated or not. Can be 0 (not calculated) or 1 (calculated).")
    code: Optional[Dict[str, Any]] = Field(default=None, description="Code and value pairs for the field.")
    info: Optional[FieldInfoBasicResponseInfo] = None
    __properties = ["uniqueId", "fieldId", "fieldName", "fieldType", "fieldSubType", "isCalculated", "code", "info"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> FieldInfoBasicResponse:
        """Create an instance of FieldInfoBasicResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of info
        if self.info:
            _dict['info'] = self.info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> FieldInfoBasicResponse:
        """Create an instance of FieldInfoBasicResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return FieldInfoBasicResponse.parse_obj(obj)

        # raise errors for additional fields in the input
        for _key in obj.keys():
            if _key not in cls.__properties:
                raise ValueError("Error due to additional fields (not defined in FieldInfoBasicResponse) in the input: " + obj)

        _obj = FieldInfoBasicResponse.parse_obj({
            "unique_id": obj.get("uniqueId"),
            "field_id": obj.get("fieldId"),
            "field_name": obj.get("fieldName"),
            "field_type": obj.get("fieldType"),
            "field_sub_type": obj.get("fieldSubType"),
            "is_calculated": obj.get("isCalculated"),
            "code": obj.get("code"),
            "info": FieldInfoBasicResponseInfo.from_dict(obj.get("info")) if obj.get("info") is not None else None
        })
        return _obj


